#pragma once

#include "stdafx.h"
#include <string>
#include "resource.h"
#include "CSmtp.h"

using namespace std;

#define STARTBTN_ID_BASE	WM_USER
#define DELETEBTN_ID_BASE   (WM_USER + 100)
#define EDITBTN_ID_BASE		(WM_USER + 200)
#define RELOADCFGTEBTN_ID_BASE   (WM_USER + 300)
#define OPENPATHBTN_ID_BASE		(WM_USER + 400)
#define CTRL_HEIGHT			30

extern CString GetModuleDir();

struct ServerInfo
{
public:
	ServerInfo(int id = 0, string name = "", string processName = "", string commandline = "")
		: id_(id)
		, name_(name)
		, processName_(processName)
		, commandline_(commandline)
		, pid_(0)
		, listenAddr_("")
	{

	}

public:
	int id_;
	string name_;
	string processName_;
	string commandline_;
	int pid_;
	string listenAddr_;
	CTime startupTime_;
};

struct AlertMailSetting
{
	string smtpServer_;
	string smtpPort_;
	string smtpUser_;
	string smtpPassword_;
	string mailTo_;
	int minAlertInterval_ = 5;
};

class CSvrProcessCtrl
{
public:
	CSvrProcessCtrl(int id = 0, string name = "", string commandline = "");
	~CSvrProcessCtrl();

public:	
	bool Create(CWnd* parent = NULL);
	UINT32 GenStartBtnID()
	{
		return STARTBTN_ID_BASE + serverInfo_.id_;
	}
	UINT32 GenDeleteBtnID()
	{
		return DELETEBTN_ID_BASE + serverInfo_.id_;
	}
	UINT32 GenEditBtnID()
	{
		return EDITBTN_ID_BASE + serverInfo_.id_;
	}
	UINT32 GenReLoadCfgBtnID()
	{
		return RELOADCFGTEBTN_ID_BASE + serverInfo_.id_;
	}
	UINT32 GenOpenPathBtnID()
	{
		return OPENPATHBTN_ID_BASE + serverInfo_.id_;
	}
	void SetServerInfo(const ServerInfo& serverInfo)
	{
		serverInfo_ = serverInfo;
	}
	static void SetAlertMailSetting(string server, string port, string user, string password, string mailto, int minInterval)
	{
		alertMailSetting_.smtpServer_ = server;
		alertMailSetting_.smtpPort_ = port;
		alertMailSetting_.smtpUser_ = user;
		alertMailSetting_.smtpPassword_ = password;
		alertMailSetting_.mailTo_ = mailto;
		alertMailSetting_.minAlertInterval_ = minInterval;
	}
	static AlertMailSetting GetAlertMailSetting()
	{
		return alertMailSetting_;
	}
	static bool smtp_sendmail(string smtpserver, string smtpport, string smtpuser,
		string smtppassword, string subject, string message,
		string mailto_list, string fileName, string& errmsg);

	bool Start();
	bool Stop(bool autoStart = false);
	bool CheckProcessStatus();
	void UpdateStatus();
	bool IsAutoStart()
	{
		return autoStart_;
	}
	const ServerInfo& GetServerInfo()
	{
		return serverInfo_;
	}
	
private:
	int GetPidByCmdline();	
	int GetPidByCmdline1();
	string GetListenAddrByPID();
	string GetListenAddrByPID1();
	void GetStartupTimeByPID(CTime& cStartupTime);
	void SendAlertMail(string message, string subject = "26300 澯ʼ");

public:
	static void CreateHeader(CWnd* parent);
	static void SetHeaderTopLeft(int x, int y)
	{
		headerTopLeft_ = CPoint(x, y);
	}
	static int GetBottom()
	{
		return headerTopLeft_.y + CTRL_HEIGHT * count_;
	}
	static int GetRight()
	{
		return headerTopLeft_.x + 150 + 200 + 515 + 60 + 150 + 80 + 80 + 20 * 6;
	}

	static int count_;
	CStatic textName_;
	CStatic textProcessName_;
	CStatic textCommandline_;
	CStatic textPid_;
	CStatic textListenAddr_;	
	CStatic textStartupTime_;
	static CFont  m_font;

	static CStatic header1;
	static CStatic header2;
	static CStatic header3;
	static CStatic header4;
	static CStatic header5;
	static CStatic header6;
	static CStatic header7;
	static CPoint headerTopLeft_;

	CButton btnStart_;
	CButton btnDelete_;
	CButton btnEdit_;

	CButton btnReLoadCfg_;
	CButton btnOpenPath_;

private:
	CWnd * parent_;
	ServerInfo serverInfo_;
	bool autoStart_ = true;
	bool isCtrlsCreated_ = false;	
	static AlertMailSetting alertMailSetting_;
};

